package com.company.jmixreporting.entity;

import io.jmix.core.DeletePolicy;
import io.jmix.core.annotation.DeletedBy;
import io.jmix.core.annotation.DeletedDate;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.entity.annotation.OnDelete;
import io.jmix.core.metamodel.annotation.Composition;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import jakarta.persistence.*;
import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.LastModifiedBy;
import org.springframework.data.annotation.LastModifiedDate;

import java.time.OffsetDateTime;
import java.util.List;
import java.util.UUID;

@JmixEntity
@Table(name = "BETA", indexes = {
        @Index(name = "IDX_BETA_ALPHA_TWO", columnList = "ALPHA_TWO_ID"),
        @Index(name = "IDX_BETA_ALPHA_THREE", columnList = "ALPHA_THREE_ID"),
        @Index(name = "IDX_BETA_ALPHA_FOUR", columnList = "ALPHA_FOUR_ID"),
        @Index(name = "IDX_BETA_GAMMA_ONE", columnList = "GAMMA_ONE_ID"),
        @Index(name = "IDX_BETA_GAMMA_TWO", columnList = "GAMMA_TWO_ID"),
        @Index(name = "IDX_BETA_DELTA_ONE", columnList = "DELTA_ONE_ID"),
        @Index(name = "IDX_BETA_DELTA_TWO", columnList = "DELTA_TWO_ID")
})
@Entity
public class Beta {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @JoinColumn(name = "DELTA_ONE_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private Delta deltaOne;

    @JoinColumn(name = "DELTA_TWO_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private Delta deltaTwo;

    @OnDelete(DeletePolicy.CASCADE)
    @Composition
    @OneToMany(mappedBy = "beta")
    private List<Omega> manyOmegas;

    @OnDelete(DeletePolicy.CASCADE)
    @Composition
    @OneToMany(mappedBy = "beta")
    private List<Kappa> manyKappas;

    @Column(name = "CODE")
    private String code;

    @InstanceName
    @Column(name = "NAME")
    private String name;

    @JoinColumn(name = "ALPHA_ONE_ID")
    @OneToOne(fetch = FetchType.LAZY)
    private Alpha alphaOne;

    @OneToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "ALPHA_TWO_ID")
    private Alpha alphaTwo;

    @OneToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "ALPHA_THREE_ID")
    private Alpha alphaThree;

    @JoinColumn(name = "ALPHA_FOUR_ID")
    @OneToOne(fetch = FetchType.LAZY)
    private Alpha alphaFour;

    @JoinColumn(name = "GAMMA_ONE_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private Gamma gammaOne;

    @JoinColumn(name = "GAMMA_TWO_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private Gamma gammaTwo;

    @Column(name = "VERSION", nullable = false)
    @Version
    private Integer version;

    @CreatedBy
    @Column(name = "CREATED_BY")
    private String createdBy;

    @CreatedDate
    @Column(name = "CREATED_DATE")
    private OffsetDateTime createdDate;

    @LastModifiedBy
    @Column(name = "LAST_MODIFIED_BY")
    private String lastModifiedBy;

    @LastModifiedDate
    @Column(name = "LAST_MODIFIED_DATE")
    private OffsetDateTime lastModifiedDate;

    @DeletedBy
    @Column(name = "DELETED_BY")
    private String deletedBy;

    @DeletedDate
    @Column(name = "DELETED_DATE")
    private OffsetDateTime deletedDate;

    public List<Kappa> getManyKappas() {
        return manyKappas;
    }

    public void setManyKappas(List<Kappa> manyKappas) {
        this.manyKappas = manyKappas;
    }

    public List<Omega> getManyOmegas() {
        return manyOmegas;
    }

    public void setManyOmegas(List<Omega> manyOmegas) {
        this.manyOmegas = manyOmegas;
    }

    public Delta getDeltaTwo() {
        return deltaTwo;
    }

    public void setDeltaTwo(Delta deltaTwo) {
        this.deltaTwo = deltaTwo;
    }

    public Delta getDeltaOne() {
        return deltaOne;
    }

    public void setDeltaOne(Delta deltaOne) {
        this.deltaOne = deltaOne;
    }

    public Gamma getGammaTwo() {
        return gammaTwo;
    }

    public void setGammaTwo(Gamma gammaTwo) {
        this.gammaTwo = gammaTwo;
    }

    public Gamma getGammaOne() {
        return gammaOne;
    }

    public void setGammaOne(Gamma gammaOne) {
        this.gammaOne = gammaOne;
    }

    public Alpha getAlphaFour() {
        return alphaFour;
    }

    public void setAlphaFour(Alpha alphaFour) {
        this.alphaFour = alphaFour;
    }

    public void setAlphaOne(Alpha alphaOne) {
        this.alphaOne = alphaOne;
    }

    public Alpha getAlphaOne() {
        return alphaOne;
    }

    public Alpha getAlphaThree() {
        return alphaThree;
    }

    public void setAlphaThree(Alpha alphaThree) {
        this.alphaThree = alphaThree;
    }

    public Alpha getAlphaTwo() {
        return alphaTwo;
    }

    public void setAlphaTwo(Alpha alphaTwo) {
        this.alphaTwo = alphaTwo;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public OffsetDateTime getDeletedDate() {
        return deletedDate;
    }

    public void setDeletedDate(OffsetDateTime deletedDate) {
        this.deletedDate = deletedDate;
    }

    public String getDeletedBy() {
        return deletedBy;
    }

    public void setDeletedBy(String deletedBy) {
        this.deletedBy = deletedBy;
    }

    public OffsetDateTime getLastModifiedDate() {
        return lastModifiedDate;
    }

    public void setLastModifiedDate(OffsetDateTime lastModifiedDate) {
        this.lastModifiedDate = lastModifiedDate;
    }

    public String getLastModifiedBy() {
        return lastModifiedBy;
    }

    public void setLastModifiedBy(String lastModifiedBy) {
        this.lastModifiedBy = lastModifiedBy;
    }

    public OffsetDateTime getCreatedDate() {
        return createdDate;
    }

    public void setCreatedDate(OffsetDateTime createdDate) {
        this.createdDate = createdDate;
    }

    public String getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(String createdBy) {
        this.createdBy = createdBy;
    }

    public Integer getVersion() {
        return version;
    }

    public void setVersion(Integer version) {
        this.version = version;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}